##########################################################
###Written by Toshio Morizane, MD & PhD, April 30, 2014###
##########################################################
reiv=function(){
###Read in and structure  multiple meta-analysis data.
lnum=length(exdat[,1]);son=0;atta=0;snum=0
dat=NULL;label=NULL;lab=NULL

for(i in 1:lnum){

if(son==1){
haba=length(exdat[i,])-1
dat=rbind(dat,exdat[i,1:haba])
if(exdat[i,1]!=""){
snum=snum+1
}
}

if(exdat[i,1]=="author"){
son=1
atta=1
for(k in 1:length(exdat[i,])){
if(exdat[i,k]=="label"){
nagasa=k-1
for(m in 1:7){
label=cbind(label,toString(exdat[i+m,k]))
}
}
}

for(n in 1:nagasa){
lab=cbind(lab,toString(exdat[i,n]))
}

}

if(exdat[i,1]=="" | i==lnum){
if(atta==1){
son=0
dat=dat[,1:nagasa]
lab=lab[1:nagasa]
colnames(dat)=lab
dat[dat==""]=NA
ma(label,dat,snum)
atta=0;snum=0
dat=NULL;label=NULL;lab=NULL
}
}

}
}
#######
ma=function(label,dat,snum){
#Plot setting.
fsfn=1.0			#font size for funnel plot.
fs=1.0				#font size for forest plot.
dwid=11.3			#window device width.
takasa=snum*0.32+3.2		#window device height (par("din"))
if(takasa>6){
#takasa=6
fs=fsfn*6/takasa		#adjusted font size for forest plot.
dwid=dwid*6/(takasa-1)		#window device width.
}

#Effect measure argument for rma( ).
lab=label
dat=na.omit(dat)
es=label[6]
mod=label[7]

pat=0
if(!is.null(dat$tneg)){
pat=1				#From four cell data of 2x2 table.
}
if(!is.null(dat$nt)){
pat=2				#From total no and event n of two groups.
}		
if(!is.null(dat$yi)){
pat=3				#From effect measure and SE (eg. ln(RR), ln(HR), ln(OR), etc.).
}
if(!is.null(dat$m1i)){
pat=4				#From continuous variable outcomes.
}


#######
#(5)Set case numbers from four cells to variables 
if(pat==1){
tpos=as.numeric(as.character(dat$tpos))
tneg=as.numeric(as.character(dat$tneg))
cpos=as.numeric(as.character(dat$cpos))
cneg=as.numeric(as.character(dat$cneg))
nt=tpos+tneg; nc=cpos+cneg;ai=tpos; bi=tneg; ci=cpos; di=cneg
}
#(6)Set case numbers from total case numbers and event numbers.
if(pat==2){
tpos=as.numeric(as.character(dat$tpos))
nt=as.numeric(as.character(dat$nt))
cpos=as.numeric(as.character(dat$cpos))
nc=as.numeric(as.character(dat$nc))
tneg=nt-tpos
cneg=nc-cpos
ai=tpos;bi=tneg;ci=cpos;di=cneg
}
#Set total case no for yi, sei.
if(pat==3){
nt=as.numeric(as.character(dat$nt))
nc=as.numeric(as.character(dat$nc))
yi=as.numeric(as.character(dat$yi))
sei=as.numeric(as.character(dat$sei))
}
#Set mean and SD for continuous variable outcomes.
if(pat==4){
m1i=as.numeric(as.character(dat$m1i))
sd1i=as.numeric(as.character(dat$sd1i))
m2i=as.numeric(as.character(dat$m2i))
sd2i=as.numeric(as.character(dat$sd2i))
n1i=as.numeric(as.character(dat$n1i))
n2i=as.numeric(as.character(dat$n2i))
nc=n2i;nt=n1i
}

####set pat if Peto or MH are indicated by lab[7].
if(mod=="Peto"){
pat=5
}
if(mod=="MH"){
pat=6
}

#######
if(pat==1|pat==2){
#(8)Meta-analysis random-effects inverse-variance method.

est=escalc(measure=es, ai=tpos, bi=tneg, ci=cpos, di=cneg, append=FALSE)
summary(est)
res=rma(yi, vi, data=est, method="REML")

#(11)Show the result of meta-analysis.
summary(res)

#(14)Forest plot with no of cases in four columns
source=lab[1]	#Study label
cgr=lab[2]	#Control group label
egr=lab[3]	#Experimental group label
outyes=lab[4]	#Outcome label
em=lab[5]		#Effect measure label

xax=res$yi[1:length(res$yi)]
wid=sqrt(res$vi[1:length(res$vi)])*1.96
xmin=min(xax-wid)
xmax=max(xax+wid)
tic=xmax-xmin
xmi=-tic*3
xma=tic*1.5
slmi=-tic*2
kan=(xma-xmi)/20
linenum=length(res$yi)+2

#(15)denominator - numerator sequence

if(es=="RD"){
dev.new(width=dwid,height=takasa)
forest(res,cex=fs,atransf=FALSE,xlim=c(xmi,xma),xlab=em, slab=dat$author, ilab=cbind(nc,ci,nt,ai),ilab.xpos=c(slmi-0.3*kan,slmi+0.9*kan,slmi+2.5*kan,slmi+3.7*kan),ilab.pos=c(4,4,4,4))
}
else
{
dev.new(width=dwid,height=takasa)
forest(res,cex=fs,atransf=exp,xlim=c(xmi,xma),xlab=em, slab=dat$author, ilab=cbind(nc,ci,nt,ai),ilab.xpos=c(slmi-0.3*kan,slmi+0.9*kan,slmi+2.5*kan,slmi+3.7*kan),ilab.pos=c(4,4,4,4))
}
text(slmi-2.8*kan,-1,pos=4,"IV",cex=fs)
text(xmi,linenum,pos=4,source,cex=fs)
text(slmi-0.3*kan,linenum,pos=4,"Total",cex=fs)
text(slmi+0.9*kan,linenum,pos=4,outyes,cex=fs)
text(slmi+2.5*kan,linenum,pos=4,"Total",cex=fs)
text(slmi+3.7*kan,linenum,pos=4,outyes,cex=fs)
text(slmi-0.3*kan,linenum+1,pos=4,cgr,cex=fs)
text(slmi+2.5*kan,linenum+1,pos=4,egr,cex=fs)
text(xma,linenum,pos=2,paste(em,"[95%CI]",sep=" "),cex=fs)
#text(0,linenum,paste("Outcome: ",outyes),cex=fs)

}
#######

if(pat==3){
#######
#(16)meta-analysis with yi, sei
res=rma(yi=yi,sei=sei,method="REML")

#(18)Forest plot with no of cases in two columns (only total case no)
source=lab[1]		#Study label
cgr=lab[2]		#Control group label
egr=lab[3]		#Experimental group label
outyes=lab[4]		#Outcome label
em=lab[5]			#Effect measure label

xax=res$yi[1:length(res$yi)]
wid=sqrt(res$vi[1:length(res$vi)])*1.96
xmin=min(xax-wid)
xmax=max(xax+wid)
tic=xmax-xmin
xmi=-tic*3
xma=tic*1.5
slmi=-tic*2
kan=(xma-xmi)/20
linenum=length(res$yi)+2

dev.new(width=dwid,height=takasa)
forest(res,cex=fs,atransf=exp,xlim=c(xmi,xma),xlab=em, slab=dat$author, ilab=cbind(nc,nt),ilab.xpos=c(slmi-0.3*kan,slmi+2.5*kan),ilab.pos=c(4,4))
text(slmi-2.8*kan,-1,pos=4,"IV",cex=fs)
text(xmi,linenum,pos=4,source,cex=fs)
text(slmi-0.3*kan,linenum,pos=4,cgr,cex=fs)
text(slmi+2.5*kan,linenum,pos=4,egr,cex=fs)
text(xma,linenum,pos=2,paste(em,"[95%CI]",sep=" "),cex=fs)
text(0,linenum,paste("Outcome: ",outyes),cex=fs)
#######
}

#####
if(pat==4){
est=escalc(measure=es, m1i=m1i,sd1i=sd1i,m2i=m2i,sd2i=sd2i,n1i=n1i,n2i=n2i, append=FALSE)
summary(est)
res=rma(yi, vi, data=est, method="REML")
summary(res)

#()Forest plot with no of cases, mean, SD in six columns.
source=lab[1]	#Study label
cgr=lab[2]	#Control group label
egr=lab[3]	#Experimental group label
outyes=lab[4]	#Outcome label
em=lab[5]		#Effect measure label

xax=res$yi[1:length(res$yi)]
wid=sqrt(res$vi[1:length(res$vi)])*1.96
xmin=min(xax-wid)
xmax=max(xax+wid)
tic=xmax-xmin
xmi=-tic*3
xma=tic*1.5
slmi=-tic*2
kan=(xma-xmi)/20
linenum=length(res$yi)+2
dev.new(width=dwid,height=takasa)
forest(res,cex=fs,atransf=F,xlim=c(xmi,xma),xlab=em, slab=dat$author, ilab=cbind(nc,m2i,sd2i,nt,m1i,sd1i),ilab.xpos=c(slmi-1*kan,slmi+0.3*kan,slmi+1.3*kan,slmi+2.6*kan,slmi+3.9*kan,slmi+4.9*kan),ilab.pos=c(4,4,4,4,4,4))
text(slmi-2.8*kan,-1,pos=4,"IV",cex=fs)
text(xmi,linenum,pos=4,source,cex=fs)
text(slmi-1*kan,linenum,pos=4,"No",cex=fs)
text(slmi+0.3*kan,linenum,pos=4,"Mean  SD",cex=fs)
text(slmi+2.6*kan,linenum,pos=4,"No",cex=fs)
text(slmi+3.9*kan,linenum,pos=4,"Mean  SD",cex=fs)
text(slmi-1*kan,linenum+1,pos=4,cgr,cex=fs)
text(slmi+2.6*kan,linenum+1,pos=4,egr,cex=fs)
text(xma,linenum,pos=2,paste(em,"[95%CI]",sep=" "),cex=fs)
text(0,linenum,paste("Outcome: ",outyes),cex=fs)
}
####
####Meta-analysis with Peto's method.
if(pat==5){
res=rma.peto(ai=ai,bi=bi,ci=ci,di=di)
summary(res)

#(14)Forest plot with no of cases in four columns
source=lab[1]		#Study label
cgr=lab[2]			#Control group label
egr=lab[3]			#Experimental group label
outyes=lab[4]		#Outcome label
em="Odds Ratio"		#Effect measure label

xax=res$yi[1:length(res$yi)]
wid=sqrt(res$vi[1:length(res$vi)])*1.96
xmin=min(xax-wid)
xmax=max(xax+wid)
tic=xmax-xmin
xmi=-tic*3
xma=tic*1.5
slmi=-tic*2
kan=(xma-xmi)/20
linenum=length(res$yi)+2
#forest plot
dev.new(width=dwid,height=takasa)
forest(res,cex=fs,atransf=exp,xlim=c(xmi,xma),xlab=em, slab=dat$author, ilab=cbind(nc,ci,nt,ai),ilab.xpos=c(slmi-0.3*kan,slmi+0.9*kan,slmi+2.5*kan,slmi+3.7*kan),ilab.pos=c(4,4,4,4))
text(slmi-2.8*kan,-1,pos=4,"Peto",cex=fs)
text(xmi,linenum,pos=4,source,cex=fs)
text(slmi-0.3*kan,linenum,pos=4,"Total",cex=fs)
text(slmi+0.9*kan,linenum,pos=4,outyes,cex=fs)
text(slmi+2.5*kan,linenum,pos=4,"Total",cex=fs)
text(slmi+3.7*kan,linenum,pos=4,outyes,cex=fs)
text(slmi-0.3*kan,linenum+1,pos=4,cgr,cex=fs)
text(slmi+2.5*kan,linenum+1,pos=4,egr,cex=fs)
text(xma,linenum,pos=2,paste(em,"[95%CI]",sep=" "),cex=fs)
#text(0,linenum,paste("Outcome: ",outyes),cex=fs)

#(19)Add legend about p value, Q statistic, etc.
#z and p value
zstr=toString(round(res$zval,digits=2))
text(slmi-0.8*kan,-0.8,pos=4,paste("z=",zstr,sep=""),cex=fs)
pzstr=toString(round(res$pval,digits=5))
text(slmi+0.8*kan,-0.8,pos=4,paste("p=",pzstr,sep=""),cex=fs)
#Q and p value
qstr=toString(round(res$QE,digits=2))
text(slmi-0.8*kan,-1.6,pos=4,paste("Q=",qstr,sep=""),cex=fs)
pqstr=toString(round(res$QEp,digits=5))
text(slmi+0.8*kan,-1.6,pos=4,paste("p=",pqstr,sep=""),cex=fs)
#tau^2
tau=toString(round(res$tau2,digits=2))
text(slmi+2.6*kan,-0.8,pos=4,"tau",cex=fs)
text(slmi+3.3*kan,-0.8,pos=3,"2",offset=0.06,cex=fs*0.8)
text(slmi+3.2*kan,-0.8,pos=4,paste("=",tau,sep=""),cex=fs)

}
#####
####Meta-analysis with Mantel-Haenszel's method.
if(pat==6){
res=rma.mh(ai=ai,bi=bi,ci=ci,di=di,measure=es)
summary(res)

#(14)Forest plot with no of cases in four columns
source=lab[1]		#Study label
cgr=lab[2]			#Control group label
egr=lab[3]			#Experimental group label
outyes=lab[4]		#Outcome label
em=lab[5]		#Effect measure label

xax=res$yi[1:length(res$yi)]
wid=sqrt(res$vi[1:length(res$vi)])*1.96
xmin=min(xax-wid)
xmax=max(xax+wid)
tic=xmax-xmin
xmi=-tic*3
xma=tic*1.5
slmi=-tic*2
kan=(xma-xmi)/20
linenum=length(res$yi)+2
#forest plot
dev.new(width=dwid,height=takasa)
forest(res,cex=fs,atransf=exp,xlim=c(xmi,xma),xlab=em, slab=dat$author, ilab=cbind(nc,ci,nt,ai),ilab.xpos=c(slmi-0.3*kan,slmi+0.9*kan,slmi+2.5*kan,slmi+3.7*kan),ilab.pos=c(4,4,4,4))
text(slmi-2.8*kan,-1,pos=4,"MH",cex=fs)
text(xmi,linenum,pos=4,source,cex=fs)
text(slmi-0.3*kan,linenum,pos=4,"Total",cex=fs)
text(slmi+0.9*kan,linenum,pos=4,outyes,cex=fs)
text(slmi+2.5*kan,linenum,pos=4,"Total",cex=fs)
text(slmi+3.7*kan,linenum,pos=4,outyes,cex=fs)
text(slmi-0.3*kan,linenum+1,pos=4,cgr,cex=fs)
text(slmi+2.5*kan,linenum+1,pos=4,egr,cex=fs)
text(xma,linenum,pos=2,paste(em,"[95%CI]",sep=" "),cex=fs)
#text(0,linenum,paste("Outcome: ",outyes),cex=fs)

#(19)Add legend about p value, Q statistic, etc.
#z and p value
zstr=toString(round(res$zval,digits=2))
text(slmi-0.8*kan,-0.8,pos=4,paste("z=",zstr,sep=""),cex=fs)
pzstr=toString(round(res$pval,digits=5))
text(slmi+0.8*kan,-0.8,pos=4,paste("p=",pzstr,sep=""),cex=fs)
#Q and p value
qstr=toString(round(res$QE,digits=2))
text(slmi-0.8*kan,-1.6,pos=4,paste("Q=",qstr,sep=""),cex=fs)
pqstr=toString(round(res$QEp,digits=5))
text(slmi+0.8*kan,-1.6,pos=4,paste("p=",pqstr,sep=""),cex=fs)

}
#####
if(pat>0 & pat<5){
###Common procedure###
#(19)Add legend about p value, Q statistic, etc.
#z and p value
zstr=toString(round(res$zval,digits=2))
text(slmi-0.8*kan,-0.8,pos=4,paste("z=",zstr,sep=""),cex=fs)
pzstr=toString(round(res$pval,digits=5))
text(slmi+0.8*kan,-0.8,pos=4,paste("p=",pzstr,sep=""),cex=fs)
#Q and p value
qstr=toString(round(res$QE,digits=2))
text(slmi-0.8*kan,-1.6,pos=4,paste("Q=",qstr,sep=""),cex=fs)
pqstr=toString(round(res$QEp,digits=5))
text(slmi+0.8*kan,-1.6,pos=4,paste("p=",pqstr,sep=""),cex=fs)
#tau^2 and I^2
tau=toString(round(res$tau2,digits=2))
text(slmi+2.6*kan,-0.8,pos=4,"tau",cex=fs)
text(slmi+3.3*kan,-0.8,pos=3,"2",offset=0.06,cex=fs*0.8)
text(slmi+3.2*kan,-0.8,pos=4,paste("=",tau,sep=""),cex=fs)
htwo=toString(round(res$I2,digits=2))
text(slmi+2.6*kan,-1.6,pos=4,"I",cex=fs)
text(slmi+3*kan,-1.6,pos=3,"2",offset=0.06,cex=fs*0.8)
text(slmi+3.2*kan,-1.6,pos=4,paste("=",htwo,sep=""),cex=fs)
}

#(21)Test of funnel plot asymmetry, Eggers' test
if(pat<5){
egger=regtest(res, model="lm", predictor="sei", ret.fit=FALSE)
}

#(22)Test of funnel plot asymmetry, Begg's test
begg=ranktest(res)


#(20)Funnel plot
dev.new(width=6,height=6)
funnel(res,xlab=paste(em,": ",outyes,sep=""))

funmax=par("usr")[3]-par("usr")[4]
gyou=funmax/12
fxmax=par("usr")[2]-(par("usr")[2]-par("usr")[1])/40
text(fxmax,gyou*0.5,"Begg's test",pos=2,cex=fsfn)
kentau=toString(round(begg$tau,digits=3))
text(fxmax,gyou*1.2,paste("Kendall's tau=",kentau,sep=""),pos=2,cex=fsfn)
kenp=toString(round(begg$pval,digits=5))
text(fxmax,gyou*1.9,paste("p=",kenp,sep=""),pos=2,cex=fsfn)

if(pat<5){
text(fxmax,gyou*3.5,"Egger's test",pos=2,cex=fsfn)
tstat=toString(round(egger$zval,digits=3))
text(fxmax,gyou*4.2,paste("t statistic=",tstat,sep=""),pos=2,cex=fsfn)
tstap=toString(round(egger$pval,digits=5))
text(fxmax,gyou*5.1,paste("p=",tstap,sep=""),pos=2,cex=fsfn)
}

##Print out the results of funnel plot asymmetry:
print("Meta-analysis")
if(pat<5){
print("Random-effects model with inverse variance-based method")
}
if(pat==5){
print("Fixed-effects model with Peto's method")
}
if(pat==6){
print("Fixed-effects model with Mantel-Haenszel's method")
}
print(paste(em," (",es,")",sep=""))
print(summary(res))

if(pat<5){
print("Egger's test:")
print(egger)
}

print("Begg's test")
print(begg)


#If the data format does not fit the above
if(pat==0){
print("Data format or type of effect measure does not fit.")
}
}
####     ####
##########################################################
